//============================================================================
//	aisa45s.pas
//
//	aISA-A45
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/11/11
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
unit aisa45s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa45w, Classes, Controls, StdCtrls;

const
	szTitle = 'Sample';
	szA45	= 'aISA-A45';
	WM_AISA_INTERRUPT = $6000;
	WM_AISA45_EOC							= WM_AISA_INTERRUPT + WM_EOC;
	WM_AISA45_BUFF_HALF_FULL	= WM_AISA_INTERRUPT + WM_BUFF_HALF_FULL;
	WM_AISA45_BUFF_FULL				= WM_AISA_INTERRUPT + WM_BUFF_FULL;
	WM_AISA45_BUFF_OVERFLOW		= WM_AISA_INTERRUPT + WM_BUFF_OVERFLOW;
	WM_AISA45_SAMPLING_OVERRUN= WM_AISA_INTERRUPT + WM_SAMPLING_OVERRUN;

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
		procedure CloseJob(Sender: TObject; var Action: TCloseAction);
	private
		gwLogSlot:	Word;
		function Aisa45sCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase:UINT): Boolean;
		function Aisa45sClose(wLogSlot: Word): Boolean;
		function Aisa45sGetResource(wLogSlot: Word): Boolean;
		function Aisa45sInPort(wLogSlot: Word): Boolean;
		function Aisa45sStartSample(wLogSlot: Word): Boolean;
		function Aisa45sGetData(wLogSlot: Word): Boolean;
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	protected
		procedure MessageIntrEoc(var Msg: TMessage);	message			WM_AISA45_EOC;
		procedure MessageIntrHalf(var Msg: TMessage);	message 		WM_AISA45_BUFF_HALF_FULL;
		procedure MessageIntrFull(var Msg: TMessage);	message			WM_AISA45_BUFF_FULL;
		procedure MessageIntrOverFlow(var Msg: TMessage);	message	WM_AISA45_BUFF_OVERFLOW;
		procedure MessageIntrOverRun(var Msg: TMessage);	message	WM_AISA45_SAMPLING_OVERRUN;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
	if Aisa45sCreate(gwLogSlot, WindowHandle, WM_AISA_INTERRUPT) = True then begin
		if Aisa45sGetResource(gwLogSlot) = True then begin
			if Aisa45sInPort(gwLogSlot) = True then
				Aisa45sStartSample(gwLogSlot);
		end;
	end;
end;
//============================================================================
//	۸т̏I
//============================================================================
procedure TForm1.CloseJob(Sender: TObject; var Action: TCloseAction);
begin
	Aisa45sClose(gwLogSlot);
end;
//============================================================================
//	aisa45.dll ̎gp錾gp޲T
//============================================================================
function TForm1.Aisa45sCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase:UINT): Boolean;
var
	szBuf: String;
begin
	//-------------------------------------------------
	//	aisa45.dll̎gp錾
	//-------------------------------------------------
	Result := Aisa45wDllOpen();
	if Result = True then begin
		//-------------------------------------------------
		//	gp޲TAۯĔԍ\܂
		//-------------------------------------------------
		pwLogSlot := AISA45_SLOT_AUTO;
		Result := Aisa45wCreate(pwLogSlot, hWnd, uWMBase);
		if Result = True then begin
			szBuf := Format('aISA-A45 Created'#10#10 + 'Slot: %2d', [pwLogSlot]);
			ResultMessage(szBuf);
		end
		else
			Aisa45wDllClose();
	end;
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if Result <> True then begin
		ErrorMessage(AISA45_SLOT_AUTO);
		pwLogSlot := AISA45_SLOT_AUTO;
	end;
end;
//============================================================================
//	aISA-A45̎gpJ
//============================================================================
function TForm1.Aisa45sClose(wLogSlot: Word): Boolean;
begin
	Result := True;
	if wLogSlot <> AISA45_SLOT_AUTO then begin
		//-------------------------------------------------
		//	aISA-A45̎gpJ
		//-------------------------------------------------
		if Aisa45wClose(wLogSlot) <> True then begin
			ErrorMessage(AISA45_SLOT_AUTO);
			Result := False;
		end;
		//-------------------------------------------------
		//	aisa45.dll ̎gpJ
		//-------------------------------------------------
		if Aisa45wDllClose() <> True then begin
			Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
			Result := False;
		end;
	end;
end;
//============================================================================
//	aISA-A45ؿ擾\
//============================================================================
function TForm1.Aisa45sGetResource(wLogSlot: Word): Boolean;
var
	Ri: TAISA45RESOURCE;
	dwDLLVer, dwDriverVer: DWord;
	szBuf: String;
begin
	//-------------------------------------------------
	//	aISA-A45ؿ擾
	//-------------------------------------------------
	Result := Aisa45wGetResource(wLogSlot, Ri);
	if Result = True then begin
		szBuf := Format( 'Board Name: %s'#10 +
										 'NumPorts: %2d'#10 +
										 'IO Address: %04xH-%04xH'#10 +
										 'IRQ: %2d'
										 ,[ szA45, Ri.dwIOPortLength[1]
										 ,	Ri.dwIOPortBase[1]
										 ,	Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1
										 ,	Ri.dwIRQRegisters[1] ]
		);
		ResultMessage(szBuf);
		//-------------------------------------------------
		//	aISA-A45 DLL,VxDްޮݔԍ擾ƕ\
		//-------------------------------------------------
		Result := Aisa45wGetVersion(dwDLLVer, dwDriverVer);
		if Result = True then begin
			szBuf := Format('GetVersion'#10 +
											'DLL    Version: %08xH'#10 +
											'Driver Version: %08xH'
											,[dwDLLVer, dwDriverVer]
			);
			ResultMessage(szBuf);
		end;
	end;
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if Result <> True then
		ErrorMessage(wLogSlot);
end;
//============================================================================
//	aISA-A45߰Ă͂\
//============================================================================
function TForm1.Aisa45sInPort(wLogSlot: Word): Boolean;
var
	wBotn: Word;
	cbDat: Byte;
	szBuf: String;
begin
	//-------------------------------------------------
	//	aISA-A45߰Ă͂ް\
	//-------------------------------------------------
	repeat
		wBotn := IDYES;
		Result := Aisa45wInPort(wLogSlot, cbDat);
		if Result = True then begin
			szBuf := Format('߰ē'#10 + 'Port In Data: %02xH'#10#10+ 'ē͂܂',[cbDat]);
			wBotn := Application.MessageBox(PChar(szBuf), szTitle, MB_YESNO);
		end;
	until (wBotn <> IDYES) or (Result <> True);
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if Result <> True then
		ErrorMessage(wLogSlot);
end;
//============================================================================
//	aISA-A45A/DJn
//============================================================================
function TForm1.Aisa45sStartSample(wLogSlot: Word): Boolean;
var
	Md:	TAISA45MODE;
begin
	//-------------------------------------------------
	//	ݸӰނݒ肵ݸފJn
	//-------------------------------------------------
	Md.dwMode		:= 2;
	Md.dwChFirst:= 0;
	Md.dwChLast	:= 31;
	Md.cwBuffer	:= 32 * 2;
	Md.dwTimer	:= $14;						//20mSϰ
	Result := Aisa45wSetMode(wLogSlot, Md);
	if Result = TRUE then
			Result := Aisa45wStartSampling(wLogSlot);
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if Result <> True then
		ErrorMessage(wLogSlot);
end;
//============================================================================
//	aISA-A45A/D͂\
//============================================================================
function TForm1.Aisa45sGetData(wLogSlot: Word): Boolean;
var
	cwNumData: DWORD;
	cwNum: DWORD;
	dwStatus:DWORD;
	pwData,pwPtr:	PWORD;
	szBuf:	String;
	wBotn:Word;
begin
	//-------------------------------------------------
	//	ݸސ擾ݸް̈m
	//-------------------------------------------------
	Result := Aisa45wGetSamplingStatus(wLogSlot,cwNumData,dwStatus);
	if (Result = True) and (cwNumData > 0) then begin
		GetMem(pwData, cwNumData*2);
		if pwData <> nil then begin
			//-------------------------------------------------
			//	ݸް擾ĕ\
			//-------------------------------------------------
			Result := Aisa45wGetData(wLogSlot, cwNumData, pwData^);
			if Result = True then begin
				szBuf := Format('[ A/Dް  LogSlot:%d]',[wLogSlot]);
				pwPtr := pwData;
			 	for cwNum:=1 to cwNumData do begin
					if 1 = (cwNum mod 4) then
						szBuf := Format('%s'#10,[szBuf]);
					szBuf := Format('%s'#9 + 'CH%2d:%03X',[szBuf,cwNum, pwPtr^]);
					inc(pwPtr);
				end;
				//-------------------------------------------------
				//	ݸް\čē͂邩mF
				//-------------------------------------------------
				szBuf := Format('%s'#10#10 + 'ē͂܂',[szBuf]);
				wBotn := Application.MessageBox(PChar(szBuf), szTitle, MB_YESNO);
				if ((wBotn = IDYES) and (Result = TRUE)) then
					Result := Aisa45sStartSample(wLogSlot)
				else
					Close;
			end;
			FreeMem(pwData);
		end
		else
			Result := False;
	end;
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if Result <> True then begin
		ErrorMessage(wLogSlot);
		Close;
	end;
end;
//============================================================================
//		EOC 荞ݔүޏ
//============================================================================
procedure TForm1.MessageIntrEoc(var Msg: TMessage);
begin
	Aisa45wStopSampling(Msg.wParam);
	Aisa45sGetData(Msg.wParam);
end;
//============================================================================
//		Half 荞ݔүޏ
//============================================================================
procedure TForm1.MessageIntrHalf(var Msg: TMessage);
begin
	Aisa45wStopSampling(Msg.wParam);
	Aisa45sGetData(Msg.wParam);
end;
//============================================================================
//		Full 荞ݔүޏ
//============================================================================
procedure TForm1.MessageIntrFull(var Msg: TMessage);
begin
	Aisa45wStopSampling(Msg.wParam);
	Aisa45sGetData(Msg.wParam);
end;
//============================================================================
//		ޯ̧ް۰ 荞ݔүޏ
//============================================================================
procedure TForm1.MessageIntrOverFlow(var Msg: TMessage);
var
	szBuf: String;
begin
	Aisa45wStopSampling(Msg.wParam);
  szBuf := Format('Log Slot:%d'#10+'ޯ̧ް۰װ܂',[Msg.wParam]);
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
	Close;
end;
//============================================================================
//		ް 荞ݔүޏ
//============================================================================
procedure TForm1.MessageIntrOverRun(var Msg: TMessage);
var
	szBuf: String;
begin
	Aisa45wStopSampling(Msg.wParam);
  szBuf := Format('Log Slot:%d'#10+'ްݥװ܂',[Msg.wParam]);
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
	Close;
end;
//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Aisa45wGetLastError(wLogSlot);
	case dwRes of
		AISA45_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		AISA45_ERR_WRAPDLL:
			szBuf := 'DLL Load error';
		else
			szBuf := Format('aISA-A45 error'#10#10'Error code: %08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

